## iqtree 1.6.1+dfsg

=== CMakeLists.txt ===
##################################################################
# IQ-TREE cmake build definition
# Copyright (c) 2012-2015 Bui Quang Minh, Lam-Tung Nguyen
##################################################################

# Windows example usages:
#------------------------
# cmake -G "Visual Studio 12" <source_dir>			(32-bit version, compiled with MSVC)
# cmake -G "Visual Studio 12 Win64" <source_dir>	(64-bit version, compiled with MSVC)
# cmake -G "Visual Studio 12 Win64" -T "Intel C++ Compiler XE 15.0" <source_dir>		(64-bit version, compiled with ICC)
# cmake -G "MinGW Makefiles" <source_dir> (TDM-GCC)
# cmake -G "Unix Makefiles" -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ -DCMAKE_MAKE_PROGRAM=mingw32-make <source_dir> (TDM-GCC and clang)

# Linux example usages:
#----------------------
# cmake <source_dir>						   (sequential version)
# cmake <source_dir>      (OpenMP version)
# cmake -DIQTREE_FLAGS="m32-single" <source_dir>      (32-bit sequential version)
# cmake -DIQTREE_FLAGS="m32" <source_dir>  (32-bit OpenMP version)
#
# To compile with CLANG on Linux:
# export CC=/usr/bin/clang
# export CXX=/usr/bin/clang++
# Best practices for setting up CMAKE for diffrent compiler can be found here:
# http://stackoverflow.com/questions/7031126/switching-between-gcc-and-clang-llvm-using-cmake
#
# Mac OSX example usages:
#------------------------
#
# To build OpenMP version one needs to download Clang version 3.7 or later (as of November 2015)
# Then assuming clang3.7 and clang++3.7 are the newly built compilers, then:
# cmake -DCMAKE_C_COMPILER=clang3.7 -DCMAKE_CXX_COMPILER=clang++3.7 <source_dir>   (OpenMP version)
#
# cmake -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ -DIQTREE_FLAGS=single <source_dir>   (sequential version)
#


# Compile OpenMP version: cmake ....
# Compile 32-bit version: cmake -DIQTREE_FLAGS=m32 ....
# Compile static version: cmake -DIQTREE_FLAGS=static ....
# Compile static OpenMP version: cmake -DIQTREE_FLAGS="static" ....

#NOTE: Static linking with clang windows: make a symlink libgcc_eh.a to libgcc.a (administrator required)
# C:\TDM-GCC-64\lib\gcc\x86_64-w64-mingw32\5.1.0>mklink libgcc_eh.a libgcc.a

cmake_minimum_required(VERSION 2.8.10 FATAL_ERROR)
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

project(iqtree)
add_definitions(-DIQ_TREE)
# The version number.
set (iqtree_VERSION_MAJOR 1)
set (iqtree_VERSION_MINOR 6)
set (iqtree_VERSION_PATCH "1")

set(BUILD_SHARED_LIBS OFF)

if (CMAKE_C_COMPILER MATCHES "mpic")
    set(IQTREE_FLAGS "${IQTREE_FLAGS} mpi")
endif()

message("IQ-TREE flags : ${IQTREE_FLAGS}")

if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release")
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Release")
	message("Builde mode   : Release")
endif()

if (CMAKE_GENERATOR MATCHES "Xcode")
    set(CMAKE_XCODE_ATTRIBUTE_DEBUG_INFORMATION_FORMAT "dwarf-with-dsym")
endif()

include_directories("${PROJECT_SOURCE_DIR}")

##################################################################
# Detect target platforms
##################################################################
if (WIN32)
	message("Target OS     : Windows")
	# build as static binary to run on most machines
    if (IQTREE_FLAGS MATCHES "static")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
    endif()
    SET(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
    add_definitions(-DWIN32)
elseif (APPLE)
	message("Target OS     : Mac OS X")
	# to be compatible back to Mac OS X 10.7
	if (IQTREE_FLAGS MATCHES "oldmac")
		add_definitions("-mmacosx-version-min=10.5")
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.5")
	else()
		add_definitions("-mmacosx-version-min=10.7")
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mmacosx-version-min=10.7")
	endif()
    SET(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
elseif (UNIX)
	message("Target OS     : Unix")
	# build as static binary to run on most machines
    if (NOT IQTREE_FLAGS MATCHES "static")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -rdynamic")
    else()
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
    endif()
else()
	# Note that IQ-TREE has NOT been tested on other platforms
	message("Target OS     : Unknown and untested yet")
endif()

##################################################################
# Setup compiler, currently supported GCC, CLANG, MSVC, and ICC
##################################################################

set(GCC "FALSE")   #  GNU compiler
set(CLANG "FALSE") # Clang compiler
set(ICC "FALSE")   # Intel compiler
set(VCC "FALSE")   # MS Visual C Compiler, note that it is different from MSVC variable
# using C++11 standard
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

if (CMAKE_COMPILER_IS_GNUCXX)
	message("Compiler      : GNU Compiler (gcc)")
	set(GCC "TRUE")
#	set(COMBINED_FLAGS "-Wall -Wno-unused-function -Wno-sign-compare -pedantic -D_GNU_SOURCE -fms-extensions -Wno-deprecated")
	set(CMAKE_CXX_FLAGS_RELEASE "-O3 -g -ffunction-sections -fdata-sections")
	set(CMAKE_C_FLAGS_RELEASE "-O3 -g -ffunction-sections -fdata-sections")
    if (APPLE)
        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,-dead_strip")
    else()
        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,--gc-sections")
    endif()
    # require at least gcc 4.8
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
        message(FATAL_ERROR "GCC version must be at least 4.8!")
    endif()
    if (WIN32)
        # disable AVX on Windows due to memory alignment
        set(IQTREE_FLAGS "${IQTREE_FLAGS} novx")
        message("WARNING: AVX is disabled on Windows as GCC does not properly suport memory alignment")
    endif()
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	message("Compiler      : Clang")
	set(CLANG "TRUE")
#	set(COMBINED_FLAGS "-Wall -Wno-unused-function -Wno-sign-compare -pedantic -D_GNU_SOURCE -Wno-nested-anon-types")
    set(CMAKE_CXX_FLAGS_RELEASE "-O3 -ffunction-sections -fdata-sections")
    set(CMAKE_C_FLAGS_RELEASE "-O3 -ffunction-sections -fdata-sections")
    if (APPLE)
        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,-dead_strip")
    else()
        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -Wl,--gc-sections")
    endif()

    # use libc++ per default in MacOS
    if (APPLE)
        SET(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    endif()

    #remove -rdynamic for Clang under Linux
    if (UNIX AND IQTREE_FLAGS MATCHES "static")
        SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)
    endif()
elseif (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
	set(VCC "TRUE")
	message("Compiler      : MS Visual C++ Compiler")
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
	message("Compiler      : Intel C++ Compiler (icc)")
	set(ICC "TRUE")
    #set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qstd=c99")
else()
	message("Compiler      : Unknown and untested yet")
endif()

set(EXE_SUFFIX "")

if (MSVC)
	# MS Visual Studio environment
	message("Exporting MS Visual Studio projects...")
	add_definitions(/MP) # enable multi-processor compilation
	if (CMAKE_BUILD_TYPE STREQUAL "Release")
		add_definitions(/Ot /Oi)
		if (VCC)
			add_definitions(/O2)
		elseif (ICC)
            #add_definitions(/O3)
			add_definitions(/O3)
		endif()
	endif()
endif()

# enable link time optimization
if (IQTREE_FLAGS MATCHES "lto")
    #if (CLANG)
    #    set(COMBINED_FLAGS "${COMBINED_FLAGS} -flto=thin")
    #else()
        set(COMBINED_FLAGS "${COMBINED_FLAGS} -flto")
    #endif()
endif()

##################################################################
# configure MPI compilation
##################################################################

if (IQTREE_FLAGS MATCHES "mpi")
    add_definitions(-D_IQTREE_MPI)
    if (NOT CMAKE_CXX_COMPILER MATCHES "mpi")
        # if not using the MPI compiler wrapper, set own options manually 
        find_package(MPI REQUIRED)
        set(CMAKE_CXX_COMPILE_FLAGS "${CMAKE_CXX_COMPILE_FLAGS} ${MPI_CXX_COMPILE_FLAGS}")
        set(CMAKE_C_COMPILE_FLAGS "${CMAKE_C_COMPILE_FLAGS} ${MPI_C_COMPILE_FLAGS}")
        set(CMAKE_CXX_LINK_FLAGS "${CMAKE_CXX_LINK_FLAGS} ${MPI_CXX_LINK_FLAGS}")
        set(CMAKE_C_LINK_FLAGS "${CMAKE_C_LINK_FLAGS} ${MPI_C_LINK_FLAGS}")
        include_directories(${MPI_C_INCLUDE_PATH})
        include_directories(${MPI_CXX_INCLUDE_PATH})
    endif()
endif()


##################################################################
# Configure PLL build
##################################################################
if (IQTREE_FLAGS MATCHES "pll")
	add_definitions(-DUSING_PLL)
	set(EXE_SUFFIX "${EXE_SUFFIX}-pll")
endif()

##################################################################
# detect 32 or 64 bit binary
##################################################################
set (BINARY32 "FALSE")
if(CMAKE_SIZEOF_VOID_P EQUAL 4 OR IQTREE_FLAGS MATCHES "m32")
	set(BINARY32 "TRUE")
	message("Target binary : 32-bit")
	if (CMAKE_GENERATOR MATCHES "Win64")
		error("Both 32-bit and 64-bit mode cannot be specified")
	endif()
	#SET(EXE_SUFFIX "${EXE_SUFFIX}32")
	if (GCC OR CLANG) 
		set(COMBINED_FLAGS "${COMBINED_FLAGS} -m32")
  	endif()
    add_definitions(-DBINARY32)
else()
	message("Target binary : 64-bit")
endif()

if(IQTREE_FLAGS MATCHES "novx")
    add_definitions(-D__NOAVX__)
endif()

##################################################################
# configure OpenMP/PThreads compilation
# change the executable name if compiled for OpenMP parallel version
##################################################################
if (NOT IQTREE_FLAGS MATCHES "single")
	message("OpenMP        : Yes")
	#SET(EXE_SUFFIX "${EXE_SUFFIX}-omp")
	add_definitions(-D_USE_PTHREADS)
	if (MSVC)
		add_definitions(/MT)
	endif()

	if (VCC)
  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /openmp")
  		include_directories("${PROJECT_SOURCE_DIR}/pll") # for PThreads headers
	elseif (ICC)
  		if (WIN32)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qopenmp")
  			include_directories("${PROJECT_SOURCE_DIR}/pll") # for PThreads headers
        else()
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -qopenmp")
  		endif()
  	elseif (GCC)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp -pthread")
  	elseif (CLANG)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp=libomp")
  	endif()
else()
	message("OpenMP        : NONE")
endif()


if (IQTREE_FLAGS MATCHES "mpi")
	message("MPI           : Yes")
	SET(EXE_SUFFIX "${EXE_SUFFIX}-mpi")
else()
	message("MPI           : NONE")
endif()

##################################################################
# configure SSE/AVX/FMA instructions
##################################################################

SET(AVX_FLAGS "-D__SSE3 -D__AVX")
if (VCC) 
	set(AVX_FLAGS "${AVX_FLAGS} /arch:AVX")
elseif (CLANG)
	set(AVX_FLAGS "${AVX_FLAGS} -mavx")
elseif (GCC)
	set(AVX_FLAGS "${AVX_FLAGS} -mavx -fabi-version=0")
elseif (ICC)
	if (WIN32)
		 set(AVX_FLAGS "${AVX_FLAGS} /arch:avx")
	else()
		 set(AVX_FLAGS "${AVX_FLAGS} -mavx")
	endif()
endif()

SET(SSE_FLAGS "-D__SSE3")
if (VCC)
	set(SSE_FLAGS "${SSE_FLAGS} /arch:SSE2 -D__SSE3__")
elseif (GCC OR CLANG)
	set(SSE_FLAGS "${SSE_FLAGS} -msse3")
elseif (ICC)
	if (WIN32)
		set(SSE_FLAGS "${SSE_FLAGS} /arch:sse3")
	else()
		set(SSE_FLAGS "${SSE_FLAGS} -msse3")
	endif()
endif()

SET(FMA_FLAGS "-D__SSE3 -D__AVX")
if (VCC) 
	set(FMA_FLAGS "${FMA_FLAGS} /arch:AVX2")
elseif (CLANG)
	set(FMA_FLAGS "${FMA_FLAGS} -mavx -mfma")
elseif (GCC)
	set(FMA_FLAGS "${FMA_FLAGS} -mavx -fabi-version=0 -mfma")
elseif (ICC) 
	if (WIN32)
		 set(FMA_FLAGS "${FMA_FLAGS} /arch:core-avx2")
	else()
		 set(FMA_FLAGS "${FMA_FLAGS} -march=core-avx2")
	endif()
endif()

SET(AVX512_FLAGS "-D__SSE3 -D__AVX")
if (VCC)

=== gsl/CMakeLists.txt ===
add_library(gsl
binomial_tpe.cpp
multinomial.cpp
pow_int.cpp
gauss.cpp
gaussinv.cpp
gausspdf.cpp
)

=== tree/CMakeLists.txt ===
add_library(tree
constrainttree.cpp
constrainttree.h
candidateset.cpp candidateset.h
iqtree.cpp
iqtree.h
matree.cpp
matree.h
memslot.cpp memslot.h
mexttree.cpp
mexttree.h
mtree.cpp
mtree.h
mtreeset.cpp
mtreeset.h
ncbitree.cpp
ncbitree.h
node.cpp
node.h
phylokernel.h
phylokernelnew.h
phylokernelnonrev.h
phylonode.cpp
phylonode.h
phylonodemixlen.cpp
phylonodemixlen.h
phylosupertree.cpp
phylosupertree.h
phylosupertreeplen.cpp
phylosupertreeplen.h
phylotree.cpp
phylotree.h
phylotreemixlen.cpp
phylotreemixlen.h
phylotreepars.cpp
phylotreesse.cpp
quartet.cpp
supernode.cpp
supernode.h
tinatree.cpp
tinatree.h
)

target_link_libraries(tree pll model alignment)

=== utils/CMakeLists.txt ===
add_library(utils
eigendecomposition.cpp eigendecomposition.h
gzstream.cpp gzstream.h
optimization.cpp optimization.h
stoprule.cpp stoprule.h
tools.cpp tools.h
pllnni.cpp pllnni.h
checkpoint.cpp checkpoint.h
MPIHelper.cpp MPIHelper.h
)

if(ZLIB_FOUND)
  target_link_libraries(utils ${ZLIB_LIBRARIES})
else(ZLIB_FOUND)
  target_link_libraries(utils zlibstatic)
endif(ZLIB_FOUND)

target_link_libraries(utils lbfgsb)

=== debian/changelog ===
iqtree (1.6.1+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.1.3
  * debhelper 11
  * Rename build.omp/iqtree to build.omp/iqtree-omp to be consistent with
    previous builds
  * Do not install example.cf in /usr
  * Do not parse d/changelog
  * Update d/copyright
  * Use example script as autopkgtest

 -- Andreas Tille <tille@debian.org>  Fri, 16 Feb 2018 15:02:35 +0100

=== debian/control ===
Source: iqtree
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Kevin Murray <kdmfoss@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               cmake,
               libeigen3-dev,
               libsprng2-dev,
               mpi-default-dev,
               zlib1g-dev,
               help2man,
               time
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/iqtree.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/iqtree.git
Homepage: http://www.cibiv.at/software/iqtree/

Package: iqtree
Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: efficient phylogenetic software by maximum likelihood
 IQ-TREE is a very efficient maximum likelihood phylogenetic software
 with following key features among others:
 .
  * A novel fast and effective stochastic algorithm to estimate maximum
    likelihood trees. IQ-TREE outperforms both RAxML and PhyML in terms
    of likelihood while requiring similar amount of computing time (see
    Nguyen et al., 2015)
  * An ultrafast bootstrap approximation to assess branch supports (see
    Minh et al., 2013).
  * A wide range of substitution models for binary, DNA, protein, codon,
    and morphological alignments.
  * Ultrafast model selection for all data types, 10 to 100 times faster
    than jModelTest and ProtTest.
  * Finding best partition scheme like PartitionFinder.
  * Partitioned models with mixed data types for phylogenomic (multi-
    gene) alignments, allowing for separate, proportional, or joint
    branch lengths among genes.
  * Supporting the phylogenetic likelihod library (PLL) (see Flouri et
    al., 2014)

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

mandir=$(CURDIR)/debian/$(DEB_SOURCE)/usr/share/man/man1/

%:
	dh $@

VARIANTS = omp serial mpi

override_dh_auto_configure: $(foreach variant,$(VARIANTS),dh_auto_configure_$(variant))
override_dh_auto_build:     $(foreach variant,$(VARIANTS),dh_auto_build_$(variant))
override_dh_auto_install:   $(foreach variant,$(VARIANTS),dh_auto_install_$(variant))
override_dh_auto_clean:     $(foreach variant,$(VARIANTS),dh_auto_clean_$(variant))

dh_auto_configure_mpi:
	dh_auto_configure -Bbuild.mpi -- -DIQTREE_FLAGS="mpi"

dh_auto_configure_omp:
	dh_auto_configure -Bbuild.omp -- -DIQTREE_FLAGS="omp"

dh_auto_configure_serial:
	dh_auto_configure -Bbuild.serial -- -DIQTREE_FLAGS=""

dh_auto_build_%:
	dh_auto_build -Bbuild.$(subst dh_auto_build_,,$@)
	# restore the old naming to avoid name space conflict with serial build
	if [ -x build.omp/iqtree ] ; then mv build.omp/iqtree build.omp/iqtree-omp ; fi

dh_auto_install_%:
	dh_auto_install -Bbuild.$(subst dh_auto_install_,,$@)

dh_auto_clean_%:
	dh_auto_clean -Bbuild.$(subst dh_auto_clean_,,$@)

override_dh_installexamples:
	# somehow the example config is installed in /usr by cmake
	find debian/$(DEB_SOURCE) -name example.cf -delete
	dh_installexamples
	# remove example files in unusual dir
	rm -f debian/*/usr/models.nex
	rm -f debian/*/usr/example.[np][eh][xy]

override_dh_installman:
	mkdir -p $(mandir)
	help2man --no-info --no-discard-stderr --help-option="-h" \
	    --name='efficient phylogenetic software by maximum likelihood' \
	    --version-string="$(DEB_VERSION_UPSTREAM)" $(CURDIR)/debian/$(DEB_SOURCE)/usr/bin/iqtree > $(mandir)/iqtree.1
	help2man --no-info --no-discard-stderr --help-option="-h" \
	    --name='efficient phylogenetic software by maximum likelihood (multiprocessor version)' \
	    --version-string="$(DEB_VERSION_UPSTREAM)" $(CURDIR)/debian/$(DEB_SOURCE)/usr/bin/iqtree-omp > $(mandir)/iqtree-omp.1
	help2man --no-info --no-discard-stderr --help-option="-h" \
	    --name='efficient phylogenetic software by maximum likelihood (multiprocessor version)' \
	    --version-string="$(DEB_VERSION_UPSTREAM)" $(CURDIR)/debian/$(DEB_SOURCE)/usr/bin/iqtree-mpi > $(mandir)/iqtree-mpi.1

override_dh_auto_test:
	# use only the first example for build time test to save time on autobuilders
#	if [ "`find $(CURDIR) -name iqtree -type f -executable`" = "" ] ; then \
#		iqtreeomp=`find $(CURDIR) -name iqtree-omp -type f -executable` ; \
#		ln -s iqtree-omp `dirname $$iqtreeomp`/iqtree ; \
#	fi
ifneq ($(shell nproc), 1)
	sed '/ myprefix/,$$d' debian/Documents_source/example.sh > example.short
	echo 'time $(CURDIR)/build.omp/iqtree-omp -s example.phy -omp 2	-redo' >> example.short
	time sh example.short
	rm example.short
endif

## iqtree 1.6.5+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -51,7 +51,7 @@
 # The version number.
 set (iqtree_VERSION_MAJOR 1)
 set (iqtree_VERSION_MINOR 6)
-set (iqtree_VERSION_PATCH "1")
+set (iqtree_VERSION_PATCH "5")
 
 set(BUILD_SHARED_LIBS OFF)
 
@@ -71,6 +71,7 @@
 
 if (CMAKE_GENERATOR MATCHES "Xcode")
     set(CMAKE_XCODE_ATTRIBUTE_DEBUG_INFORMATION_FORMAT "dwarf-with-dsym")
+    set(CMAKE_XCODE_ATTRIBUTE_COMPILER_INDEX_STORE_ENABLE "No")
 endif()
 
 include_directories("${PROJECT_SOURCE_DIR}")
@@ -277,7 +278,8 @@
   		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp -pthread")
   	elseif (CLANG)
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
-  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp=libomp")
+  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp=libomp -pthread")
+        set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fopenmp=libomp")
   	endif()
 else()
 	message("OpenMP        : NONE")
@@ -332,11 +334,3 @@
 	set(FMA_FLAGS "${FMA_FLAGS} -mavx -fabi-version=0 -mfma")
 elseif (ICC) 
 	if (WIN32)
-		 set(FMA_FLAGS "${FMA_FLAGS} /arch:core-avx2")
-	else()
-		 set(FMA_FLAGS "${FMA_FLAGS} -march=core-avx2")
-	endif()
-endif()
-
-SET(AVX512_FLAGS "-D__SSE3 -D__AVX")
-if (VCC)

=== debian/changelog ===
iqtree (1.6.5+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Delete RPATH from /usr/bin/iqtree-mpi

 -- Andreas Tille <tille@debian.org>  Tue, 22 May 2018 17:43:03 +0200

iqtree (1.6.3+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4

 -- Andreas Tille <tille@debian.org>  Thu, 26 Apr 2018 15:34:19 +0200

=== debian/control ===
--- 
+++ 
@@ -11,10 +11,11 @@
                mpi-default-dev,
                zlib1g-dev,
                help2man,
-               time
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/iqtree.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/iqtree.git
+               time,
+               chrpath
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/med-team/iqtree
+Vcs-Git: https://salsa.debian.org/med-team/iqtree.git
 Homepage: http://www.cibiv.at/software/iqtree/
 
 Package: iqtree

=== debian/rules ===
--- 
+++ 
@@ -35,6 +35,10 @@
 dh_auto_install_%:
 	dh_auto_install -Bbuild.$(subst dh_auto_install_,,$@)
 
+override_dh_install:
+	dh_install
+	find debian -name iqtree-mpi -exec chrpath --delete \{\} \;
+
 dh_auto_clean_%:
 	dh_auto_clean -Bbuild.$(subst dh_auto_clean_,,$@)

## iqtree 1.6.9+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -51,7 +51,7 @@
 # The version number.
 set (iqtree_VERSION_MAJOR 1)
 set (iqtree_VERSION_MINOR 6)
-set (iqtree_VERSION_PATCH "5")
+set (iqtree_VERSION_PATCH "9")
 
 set(BUILD_SHARED_LIBS OFF)

=== debian/changelog ===
iqtree (1.6.9+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Wed, 02 Jan 2019 14:13:38 +0100

iqtree (1.6.8+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Autopkgtest: Upstream now requires -redo option to allow overriding
    existing output data

 -- Andreas Tille <tille@debian.org>  Thu, 13 Dec 2018 20:07:24 +0100

iqtree (1.6.7.1+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.2.1
  * Delete RPATH from /usr/bin/iqtree-omp
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test

 -- Andreas Tille <tille@debian.org>  Wed, 26 Sep 2018 19:59:01 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                help2man,
                time,
                chrpath
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/med-team/iqtree
 Vcs-Git: https://salsa.debian.org/med-team/iqtree.git
 Homepage: http://www.cibiv.at/software/iqtree/

## iqtree 1.6.11+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -51,7 +51,7 @@
 # The version number.
 set (iqtree_VERSION_MAJOR 1)
 set (iqtree_VERSION_MINOR 6)
-set (iqtree_VERSION_PATCH "9")
+set (iqtree_VERSION_PATCH "11")
 
 set(BUILD_SHARED_LIBS OFF)
 
@@ -277,9 +277,14 @@
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
   		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp -pthread")
   	elseif (CLANG)
-		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
-  		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp=libomp -pthread")
-        set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fopenmp=libomp")
+        if (APPLE)
+            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Xpreprocessor -fopenmp -pthread")
+            set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Xpreprocessor -fopenmp -lomp")
+        else()
+            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp -pthread")
+        endif()
   	endif()
 else()
 	message("OpenMP        : NONE")
@@ -327,10 +332,3 @@
 
 SET(FMA_FLAGS "-D__SSE3 -D__AVX")
 if (VCC) 
-	set(FMA_FLAGS "${FMA_FLAGS} /arch:AVX2")
-elseif (CLANG)
-	set(FMA_FLAGS "${FMA_FLAGS} -mavx -mfma")
-elseif (GCC)
-	set(FMA_FLAGS "${FMA_FLAGS} -mavx -fabi-version=0 -mfma")
-elseif (ICC) 
-	if (WIN32)

=== debian/changelog ===
iqtree (1.6.11+dfsg-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.0

 -- Andreas Tille <tille@debian.org>  Sat, 27 Jul 2019 22:09:33 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
            Kevin Murray <kdmfoss@gmail.com>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                libeigen3-dev,
                libsprng2-dev,
@@ -13,7 +13,7 @@
                help2man,
                time,
                chrpath
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/med-team/iqtree
 Vcs-Git: https://salsa.debian.org/med-team/iqtree.git
 Homepage: http://www.cibiv.at/software/iqtree/

## iqtree 1.6.12+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -51,7 +51,7 @@
 # The version number.
 set (iqtree_VERSION_MAJOR 1)
 set (iqtree_VERSION_MINOR 6)
-set (iqtree_VERSION_PATCH "11")
+set (iqtree_VERSION_PATCH "12")
 
 set(BUILD_SHARED_LIBS OFF)
 
@@ -277,10 +277,10 @@
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
   		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp -pthread")
   	elseif (CLANG)
-        if (APPLE)
+        if (APPLE OR WIN32)
             set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
             set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Xpreprocessor -fopenmp -pthread")
-            set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Xpreprocessor -fopenmp -lomp")
+            set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lomp")
         else()
             set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
             set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp -pthread")

=== alignment/CMakeLists.txt ===
add_library(alignment
pattern.cpp
pattern.h
alignment.cpp
alignment.h
alignmentpairwise.cpp
alignmentpairwise.h
maalignment.cpp
maalignment.h
superalignment.cpp
superalignment.h
superalignmentpairwise.cpp
superalignmentpairwise.h
superalignmentpairwiseplen.cpp
superalignmentpairwiseplen.h
)

target_link_libraries(alignment ncl gsl)

=== ncl/CMakeLists.txt ===
add_library(ncl 
nxsassumptionsblock.cpp
nxsblock.cpp
nxscharactersblock.cpp
nxsdatablock.cpp
nxsdiscretedatum.cpp
nxsdiscretematrix.cpp
nxsdistancedatum.cpp
nxsdistancesblock.cpp
nxsemptyblock.cpp
nxsexception.cpp
nxsreader.cpp
nxssetreader.cpp
nxsstring.cpp
nxstaxablock.cpp
nxstoken.cpp
nxstreesblock.cpp)

=== nclextra/CMakeLists.txt ===
add_library(nclextra
mpdablock.cpp mpdablock.h
msetsblock.cpp msetsblock.h
msplitsblock.cpp msplitsblock.h
modelsblock.cpp modelsblock.h
)

=== sprng/CMakeLists.txt ===
add_library(sprng 
lcg64.c
makeseed.c
memory.c
store.c
primes-lcg64.c
checkid.c)

=== tree/CMakeLists.txt ===
--- 
+++ 
@@ -39,6 +39,8 @@
 supernode.h
 tinatree.cpp
 tinatree.h
+parstree.cpp
+parstree.h
 )
 
 target_link_libraries(tree pll model alignment)

=== utils/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
 pllnni.cpp pllnni.h
 checkpoint.cpp checkpoint.h
 MPIHelper.cpp MPIHelper.h
+timeutil.h
 )
 
 if(ZLIB_FOUND)

=== vectorclass/CMakeLists.txt ===
add_library(vectorclass
instrset_detect.cpp
instrset.h
vectorclass.h
vectorf64.h
vectorf128.h
vectorf256.h
vectorf512.h
)

=== whtest/CMakeLists.txt ===

include_directories("${PROJECT_BINARY_DIR}")

add_library(whtest 
eigen.c  
eigen_sym.c  
random.c  
weisslambda.c  
weisslambda_sub.c  
whtest.c  
whtest_sub.c
whtest_wrapper.cpp whtest_wrapper.h
)

#install (TARGETS whtest DESTINATION bin)
#install (FILES  eigen.h  eigen_sym.h  random.h  tools.h  weisslambda_sub.h  whtest.h  whtest_sub.h DESTINATION include)

=== debian/changelog ===
iqtree (1.6.12+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.4.1

 -- Steffen Moeller <moeller@debian.org>  Wed, 04 Dec 2019 13:52:57 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                help2man,
                time,
                chrpath
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/med-team/iqtree
 Vcs-Git: https://salsa.debian.org/med-team/iqtree.git
 Homepage: http://www.cibiv.at/software/iqtree/

=== debian/rules ===
--- 
+++ 
@@ -38,6 +38,7 @@
 override_dh_install:
 	dh_install
 	find debian -name iqtree-mpi -exec chrpath --delete \{\} \;
+	find debian -name iqtree-omp -exec chrpath --delete \{\} \;
 
 dh_auto_clean_%:
 	dh_auto_clean -Bbuild.$(subst dh_auto_clean_,,$@)
@@ -63,6 +64,7 @@
 	    --version-string="$(DEB_VERSION_UPSTREAM)" $(CURDIR)/debian/$(DEB_SOURCE)/usr/bin/iqtree-mpi > $(mandir)/iqtree-mpi.1
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# use only the first example for build time test to save time on autobuilders
 #	if [ "`find $(CURDIR) -name iqtree -type f -executable`" = "" ] ; then \
 #		iqtreeomp=`find $(CURDIR) -name iqtree-omp -type f -executable` ; \
@@ -74,3 +76,4 @@
 	time sh example.short
 	rm example.short
 endif
+endif

=== debian/watch ===
version=4

opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg,repack,compression=xz" \
  https://github.com/Cibiv/IQ-TREE/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## iqtree 2.0.7%2Bdfsg

=== yaml-cpp/CMakeLists.txt ===
###
### CMake settings
###
# see http://www.cmake.org/Wiki/CMake_Policies
cmake_minimum_required(VERSION 3.1)

include(CheckCXXCompilerFlag)

###
### Project settings
###
project(YAML_CPP)

set(YAML_CPP_VERSION_MAJOR "0")
set(YAML_CPP_VERSION_MINOR "6")
set(YAML_CPP_VERSION_PATCH "2")
set(YAML_CPP_VERSION "${YAML_CPP_VERSION_MAJOR}.${YAML_CPP_VERSION_MINOR}.${YAML_CPP_VERSION_PATCH}")


###
### Project options
###
## Project stuff
option(YAML_CPP_BUILD_TESTS "Enable testing" ON)
option(YAML_CPP_BUILD_TOOLS "Enable parse tools" ON)
option(YAML_CPP_BUILD_CONTRIB "Enable contrib stuff in library" ON)
option(YAML_CPP_INSTALL "Enable generation of install target" ON)

## Build options
# --> General
# see http://www.cmake.org/cmake/help/cmake2.6docs.html#variable:BUILD_SHARED_LIBS
#     http://www.cmake.org/cmake/help/cmake2.6docs.html#command:add_library
option(BUILD_SHARED_LIBS "Build Shared Libraries" OFF)

# Set minimum C++ to 2011 standards
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# --> Apple
option(APPLE_UNIVERSAL_BIN "Apple: Build universal binary" OFF)

# --> Microsoft Visual C++
# see http://msdn.microsoft.com/en-us/library/aa278396(v=VS.60).aspx
#     http://msdn.microsoft.com/en-us/library/2kzt1wy3(v=VS.71).aspx
option(MSVC_SHARED_RT "MSVC: Build with shared runtime libs (/MD)" ON)
option(MSVC_STHREADED_RT "MSVC: Build with single-threaded static runtime libs (/ML until VS .NET 2003)" OFF)

###
### Sources, headers, directories and libs
###

# From http://www.cmake.org/pipermail/cmake/2010-March/035992.html:
# function to collect all the sources from sub-directories
# into a single list
function(add_sources)
  get_property(is_defined GLOBAL PROPERTY SRCS_LIST DEFINED)
  if(NOT is_defined)
    define_property(GLOBAL PROPERTY SRCS_LIST
      BRIEF_DOCS "List of source files"
      FULL_DOCS "List of all source files in the entire project")
  endif()
  # make absolute paths
  set(SRCS)
  foreach(s IN LISTS ARGN)
    if(NOT IS_ABSOLUTE "${s}")
      get_filename_component(s "${s}" ABSOLUTE)
    endif()
    list(APPEND SRCS "${s}")
  endforeach()
  # append to global list
  set_property(GLOBAL APPEND PROPERTY SRCS_LIST "${SRCS}")
endfunction(add_sources)

set(header_directory "include/yaml-cpp/")

file(GLOB sources "src/[a-zA-Z]*.cpp")
file(GLOB_RECURSE public_headers "include/yaml-cpp/[a-zA-Z]*.h")
file(GLOB private_headers "src/[a-zA-Z]*.h")

if(YAML_CPP_BUILD_CONTRIB)
	file(GLOB contrib_sources "src/contrib/[a-zA-Z]*.cpp")
	file(GLOB contrib_public_headers "include/yaml-cpp/contrib/[a-zA-Z]*.h")
	file(GLOB contrib_private_headers "src/contrib/[a-zA-Z]*.h")
else()
	add_definitions(-DYAML_CPP_NO_CONTRIB)
endif()

set(library_sources
  ${sources}
  ${public_headers}
  ${private_headers}
  ${contrib_sources}
  ${contrib_public_headers}
  ${contrib_private_headers}
)
add_sources(${library_sources})

if(VERBOSE)
	message(STATUS "sources: ${sources}")
	message(STATUS "public_headers: ${public_headers}")
	message(STATUS "private_headers: ${private_headers}")
	message(STATUS "contrib_sources: ${contrib_sources}")
	message(STATUS "contrib_public_headers: ${contrib_public_headers}")
	message(STATUS "contrib_private_headers: ${contrib_private_headers}")
endif()

if (CMAKE_VERSION VERSION_LESS 2.8.12)
    include_directories(${YAML_CPP_SOURCE_DIR}/src)
    include_directories(${YAML_CPP_SOURCE_DIR}/include)
endif()


###
### General compilation settings
###
set(yaml_c_flags ${CMAKE_C_FLAGS})
set(yaml_cxx_flags ${CMAKE_CXX_FLAGS})

if(BUILD_SHARED_LIBS)
	set(LABEL_SUFFIX "shared")
else()
	set(LABEL_SUFFIX "static")
endif()

if(APPLE)
	if(APPLE_UNIVERSAL_BIN)
		set(CMAKE_OSX_ARCHITECTURES ppc;i386)
	endif()
endif()

if(IPHONE)
	set(CMAKE_OSX_SYSROOT "iphoneos4.2")
	set(CMAKE_OSX_ARCHITECTURES "armv6;armv7")
endif()

if(WIN32)
	if(BUILD_SHARED_LIBS)
		add_definitions(-D${PROJECT_NAME}_DLL)	# use or build Windows DLL
	endif()
	if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
		set(CMAKE_INSTALL_PREFIX "C:/")
	endif()
endif()

# GCC or Clang or Intel Compiler specialities
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR
   (CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND NOT "x${CMAKE_CXX_SIMULATE_ID}" STREQUAL "xMSVC") OR
   CMAKE_CXX_COMPILER_ID MATCHES "Intel")

	### General stuff
	if(WIN32)
		set(CMAKE_SHARED_LIBRARY_PREFIX "")	# DLLs do not have a "lib" prefix
		set(CMAKE_IMPORT_LIBRARY_PREFIX "")	# same for DLL import libs
		set(CMAKE_LINK_DEF_FILE_FLAG "")	# CMake workaround (2.8.3)
	endif()

	### Project stuff
	if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
		set(CMAKE_BUILD_TYPE Release)
	endif()
	#
	set(GCC_EXTRA_OPTIONS "")
	#
	if(BUILD_SHARED_LIBS)
		set(GCC_EXTRA_OPTIONS "${GCC_EXTRA_OPTIONS} -fPIC")
	endif()
	#
	set(FLAG_TESTED "-Wextra -Wshadow -Weffc++ -pedantic -pedantic-errors")
	check_cxx_compiler_flag(${FLAG_TESTED} FLAG_WEXTRA)
	if(FLAG_WEXTRA)
		set(GCC_EXTRA_OPTIONS "${GCC_EXTRA_OPTIONS} ${FLAG_TESTED}")
	endif()
	#
	set(yaml_cxx_flags "-Wall ${GCC_EXTRA_OPTIONS} -pedantic -Wno-long-long ${yaml_cxx_flags}")

	### Make specific
	if(${CMAKE_BUILD_TOOL} MATCHES make OR ${CMAKE_BUILD_TOOL} MATCHES gmake)
		add_custom_target(debuggable ${CMAKE_MAKE_PROGRAM} clean
			COMMAND ${CMAKE_COMMAND} -DCMAKE_BUILD_TYPE=Debug ${CMAKE_SOURCE_DIR}
			COMMENT "Adjusting settings for debug compilation"
			VERBATIM)
		add_custom_target(releasable ${CMAKE_MAKE_PROGRAM} clean
			COMMAND ${CMAKE_COMMAND} -DCMAKE_BUILD_TYPE=Release ${CMAKE_SOURCE_DIR}
			COMMENT "Adjusting settings for release compilation"
			VERBATIM)
	endif()
endif()

# Microsoft VisualC++ specialities
if(MSVC)
	### General stuff
	# a) Change MSVC runtime library settings (/MD[d], /MT[d], /ML[d] (single-threaded until VS 2003))
	#    plus set lib suffix for later use and project label accordingly
	# see http://msdn.microsoft.com/en-us/library/aa278396(v=VS.60).aspx
	#     http://msdn.microsoft.com/en-us/library/2kzt1wy3(v=VS.71).aspx
	set(LIB_RT_SUFFIX "md")	# CMake defaults to /MD for MSVC
	set(LIB_RT_OPTION "/MD")
	#
	if(NOT MSVC_SHARED_RT)	# User wants to have static runtime libraries (/MT, /ML)
		if(MSVC_STHREADED_RT)	# User wants to have old single-threaded static runtime libraries
			set(LIB_RT_SUFFIX "ml")
			set(LIB_RT_OPTION "/ML")
			if(NOT ${MSVC_VERSION} LESS 1400)
				message(FATAL_ERROR "Single-threaded static runtime libraries (/ML) only available until VS .NET 2003 (7.1).")
			endif()
		else()
			set(LIB_RT_SUFFIX "mt")
			set(LIB_RT_OPTION "/MT")
		endif()

		# correct linker options
		foreach(flag_var  CMAKE_C_FLAGS  CMAKE_CXX_FLAGS)
			foreach(config_name  ""  DEBUG  RELEASE  MINSIZEREL  RELWITHDEBINFO)
				set(var_name "${flag_var}")
				if(NOT "${config_name}" STREQUAL "")
					set(var_name "${var_name}_${config_name}")
				endif()
				string(REPLACE "/MD" "${LIB_RT_OPTION}" ${var_name} "${${var_name}}")
				set(${var_name} "${${var_name}}" CACHE STRING "" FORCE)
			endforeach()
		endforeach()
	endif()
	#
	set(LABEL_SUFFIX "${LABEL_SUFFIX} ${LIB_RT_SUFFIX}")

	# b) Change prefix for static libraries
	set(CMAKE_STATIC_LIBRARY_PREFIX "lib")	# to distinguish static libraries from DLL import libs

	# c) Correct suffixes for static libraries
	if(NOT BUILD_SHARED_LIBS)
		### General stuff
		set(LIB_TARGET_SUFFIX "${LIB_SUFFIX}${LIB_RT_SUFFIX}")
	endif()

	### Project stuff
	# /W3 = set warning level; see http://msdn.microsoft.com/en-us/library/thxezb7y.aspx
	# /wd4127 = disable warning C4127 "conditional expression is constant"; see http://msdn.microsoft.com/en-us/library/6t66728h.aspx
	# /wd4355 = disable warning C4355 "'this' : used in base member initializer list"; http://msdn.microsoft.com/en-us/library/3c594ae3.aspx
	set(yaml_cxx_flags "/W3 /wd4127 /wd4355 ${yaml_cxx_flags}")
endif()


###
### General install settings
###
set(INCLUDE_INSTALL_ROOT_DIR include)

set(INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_ROOT_DIR}/yaml-cpp)
set(LIB_INSTALL_DIR "lib${LIB_SUFFIX}")

set(_INSTALL_DESTINATIONS
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION ${LIB_INSTALL_DIR}
	ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
)


###
### Library
###
add_library(yaml-cpp ${library_sources})

if (NOT CMAKE_VERSION VERSION_LESS 2.8.12)
    target_include_directories(yaml-cpp
        PUBLIC $<BUILD_INTERFACE:${YAML_CPP_SOURCE_DIR}/include>
               $<INSTALL_INTERFACE:${INCLUDE_INSTALL_ROOT_DIR}>
        PRIVATE $<BUILD_INTERFACE:${YAML_CPP_SOURCE_DIR}/src>)
endif()

set_target_properties(yaml-cpp PROPERTIES
  COMPILE_FLAGS "${yaml_c_flags} ${yaml_cxx_flags}"
)

set_target_properties(yaml-cpp PROPERTIES
	VERSION "${YAML_CPP_VERSION}"
	SOVERSION "${YAML_CPP_VERSION_MAJOR}.${YAML_CPP_VERSION_MINOR}"
	PROJECT_LABEL "yaml-cpp ${LABEL_SUFFIX}"
)

if(IPHONE)
	set_target_properties(yaml-cpp PROPERTIES
		XCODE_ATTRIBUTE_IPHONEOS_DEPLOYMENT_TARGET "3.0"
	)
endif()

if(MSVC)
	if(NOT BUILD_SHARED_LIBS)
		# correct library names
		set_target_properties(yaml-cpp PROPERTIES
			DEBUG_POSTFIX "${LIB_TARGET_SUFFIX}d"
			RELEASE_POSTFIX "${LIB_TARGET_SUFFIX}"
			MINSIZEREL_POSTFIX "${LIB_TARGET_SUFFIX}"
			RELWITHDEBINFO_POSTFIX "${LIB_TARGET_SUFFIX}"
		)
	endif()
endif()

if (YAML_CPP_INSTALL)
	install(TARGETS yaml-cpp EXPORT yaml-cpp-targets ${_INSTALL_DESTINATIONS})
	install(
		DIRECTORY ${header_directory}
		DESTINATION ${INCLUDE_INSTALL_DIR}
		FILES_MATCHING PATTERN "*.h"
	)
endif()

export(
    TARGETS yaml-cpp
    FILE "${PROJECT_BINARY_DIR}/yaml-cpp-targets.cmake")
export(PACKAGE yaml-cpp)
set(EXPORT_TARGETS yaml-cpp CACHE INTERNAL "export targets")

set(CONFIG_INCLUDE_DIRS "${YAML_CPP_SOURCE_DIR}/include")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/yaml-cpp-config.cmake.in
	"${PROJECT_BINARY_DIR}/yaml-cpp-config.cmake" @ONLY)

if(WIN32 AND NOT CYGWIN)
	set(INSTALL_CMAKE_DIR CMake)
else()
	set(INSTALL_CMAKE_DIR ${LIB_INSTALL_DIR}/cmake/yaml-cpp)
endif()


file(RELATIVE_PATH REL_INCLUDE_DIR "${CMAKE_INSTALL_PREFIX}/${INSTALL_CMAKE_DIR}" "${CMAKE_INSTALL_PREFIX}/${INCLUDE_INSTALL_ROOT_DIR}")
set(CONFIG_INCLUDE_DIRS "\${YAML_CPP_CMAKE_DIR}/${REL_INCLUDE_DIR}")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/yaml-cpp-config.cmake.in
	"${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/yaml-cpp-config.cmake" @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/yaml-cpp-config-version.cmake.in
	"${PROJECT_BINARY_DIR}/yaml-cpp-config-version.cmake" @ONLY)

if (YAML_CPP_INSTALL)
	install(FILES
		"${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/yaml-cpp-config.cmake"
		"${PROJECT_BINARY_DIR}/yaml-cpp-config-version.cmake"
		DESTINATION "${INSTALL_CMAKE_DIR}" COMPONENT dev)
	install(EXPORT yaml-cpp-targets DESTINATION ${INSTALL_CMAKE_DIR})

	if(UNIX)
		set(PC_FILE ${CMAKE_BINARY_DIR}/yaml-cpp.pc)
		configure_file("yaml-cpp.pc.cmake" ${PC_FILE} @ONLY)
		install(FILES ${PC_FILE} DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
	endif()

endif()


###
### Extras
###
if(YAML_CPP_BUILD_TESTS)
	enable_testing()
	add_subdirectory(test)
endif()
if(YAML_CPP_BUILD_TOOLS)
	add_subdirectory(util)
endif()

### Formatting
get_property(all_sources GLOBAL PROPERTY SRCS_LIST)
add_custom_target(format
	COMMAND clang-format --style=file -i ${all_sources}
	COMMENT "Running clang-format"
	VERBATIM)
